\name{SROCt-package}
\alias{SROCt-package}
\alias{SROCt}
\docType{package}
\title{
Summary ROC curves based on aggregated survival data
}
\description{
Computes the SROCt curve based on aggregate data of several studies.
}
\details{
\tabular{ll}{
Package: \tab SROCt\cr
Type: \tab Package\cr
Version: \tab 0.3\cr
Date: \tab 2012-08-08\cr
License: \tab GPL (>=2)\cr
LazyLoad: \tab yes\cr
}


We propose an adaptation of the time-dependant ROC curve from published survival curves. The aggregate data used in this package are the survival probabilities in strata of the marker collected at various time-points. The cut-offs defining the strata of the marker are allowed to be different across the studies and need to be specified. The marker is assumed to be normally distributed. The survival function given the marker level is modeled with a piecewise-constant hazard function and the association of the marker is allowed to be different in each interval of time. Random effects are introduced in the models to take the inter-study variability into account. The regression coefficients are assessed by using the R package nlme. Illustrative data are provided: data from the cohort DIVAT, and data from a published meta-analysis (de Azambuja et al. 2007).


\tabular{rl}{
sroc4 \tab Compute Summary ROC curve. The hazard function associated with the time-to-event was \cr
 \eqn{ \mbox{ } }  \tab defined as a 4-piece constant function with a specific association 
of the marker  \cr
 \eqn{ \mbox{ } }  \tab  at each interval. \cr
sroc5 \tab Compute Summary ROC curve. The hazard function associated with the time-to-event was \cr
 \eqn{ \mbox{ } }  \tab defined as a 5-piece constant function with a specific association 
of the marker  \cr
 \eqn{ \mbox{ } }  \tab  at each interval. \cr
auc \tab Compute the area under the ROC curve from vectors of sensitivities and specificities  \cr
 \eqn{ \mbox{ } }  \tab   using trapezoidal rule.\cr
}
}
\author{
Y. Foucher <Yohann.Foucher@univ-nantes.fr>
}
\references{
Heagerty, P.J., Lumley, T., Pepe, M. S. (2000) Time-dependent ROC Curves for Censored Survival Data and a Diagnostic Marker.

}
\keyword{ ROC }
\keyword{ aggregated data }
\keyword{ meta analysis }
\keyword{ prognostic }
\keyword{ survival }

\seealso{
URL: http://www.divat.fr
}
